=== debian/changelog ===
php8.4 (8.4.11-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2110455). Remaining changes:
    - d/rules: enable DTrace (LP #2088977)
    - d/rules: set PHP_BUILD_PROVIDER to Ubuntu in Ubuntu builds

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 12 Aug 2025 22:43:48 -0300

php8.4 (8.4.11-1) unstable; urgency=medium

  * New upstream version 8.4.11

 -- Ondřej Surý <ondrej@debian.org>  Sun, 03 Aug 2025 09:32:21 +0200

php8.4 (8.4.8-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2110455). Remaining changes:
    - d/rules: enable DTrace (LP #2088977)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 25 Jun 2025 16:35:06 -0300

php8.4 (8.4.5-1ubuntu2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 10:04:49 +0200
