## php8.4 8.4.12

=== debian/changelog ===
php8.4 (8.4.12-3+devuan4~1) chimaera; urgency=medium

  * Resync with upstream version 8.4.12
  * Repack for devuan

 -- TDR Networks Builder <builder@tdrnetworks.com>  Wed, 17 Sep 2025 12:06:00 +0000

php8.4 (8.4.2-1+devuan4~1) chimaera; urgency=medium

  * First upstream version 8.4.2
  * Repack for devuan

 -- TDR Networks Builder <builder@tdrnetworks.com>  Fri, 10 Jan 2025 16:29:00 +0000

php8.4 (8.4.2-1+0~20241225.21+debian11~1.gbp593a82) unstable; urgency=medium

  ** SNAPSHOT build @593a82d81cdadf918c9a025643eb8d970359e3ad **

  * UNRELEASED

 -- Ondřej Surý <ondrej@sury.org>  Wed, 25 Dec 2024 14:41:28 +0100
