=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: php8.4
 Section: php
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian PHP Maintainers <team+pkg-php@tracker.debian.org>
+Maintainer: Debian PHP Maintainers <team+pkg-php@tracker.debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>,
            Lior Kaplan <kaplan@debian.org>
 Build-Depends: apache2-bin (>= 2.4),
@@ -12,7 +11,7 @@
                bison,
                chrpath,
                debhelper (>= 9.20160709~),
-               default-libmysqlclient-dev | libmysqlclient-dev,
+               default-libmysqlclient-dev | libmysqlclient-dev | libmariadb-dev,
                dh-apache2,
                dpkg-dev (>= 1.16.1~),
                firebird-dev [!hurd-any !m68k !hppa !ppc64] | firebird2.5-dev [!hurd-any !m68k !hppa !ppc64] | firebird2.1-dev [!hurd-any !m68k !hppa !ppc64],
@@ -54,12 +53,12 @@
                libsodium-dev,
                libsqlite3-dev (>= 3.7.7),
                libssl-dev (>= 1.1.1),
-               libsystemd-dev [linux-any],
                libtidy-dev (>= 1:5.2.0),
                libtool (>= 2.2),
                libwebp-dev,
                libwrap0-dev,
                libxml2-dev (>= 2.9.4),
+               libxmltok1-dev,
                libxslt1-dev (>= 1.0.18),
                libzip-dev (>= 1.0.0),
                locales-all | language-pack-de,
@@ -234,7 +233,6 @@
          php8.4-common (= ${binary:Version}),
          php8.4-opcache,
          procps,
-         systemd | systemd-tmpfiles,
          tzdata,
          ucf,
          ${misc:Depends},
@@ -352,3 +350,4 @@
 Conflicts: ${php-common:Conflicts}
 Provides: ${php-common:Provides}
 Recommends: ${php-common:Recommends}
+Description: documentation, examples and common module for PHP
