=== debian/rules ===
--- 
+++ 
@@ -25,12 +25,6 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
-
-ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
-export PHP_BUILD_PROVIDER ?= Ubuntu
-else
-export PHP_BUILD_PROVIDER ?= Debian
-endif
 
 export DEB_HOST_MULTIARCH
 PHP_SOURCE_VERSION   := $(DEB_VERSION)
@@ -40,14 +34,6 @@
 PHP_MAJOR_VERSION    := $(shell echo $(PHP_DFSG_VERSION) | awk -F. '{print $$1}')
 PHP_MINOR_VERSION    := $(shell echo $(PHP_DFSG_VERSION) | awk -F. '{print $$2}')
 PHP_RELEASE_VERSION  := $(shell echo $(PHP_DFSG_VERSION) | awk -F. '{print $$3}')
-
-ICU_VERSION := $(shell dpkg -s libicu-dev | sed -ne 's/^Version: \(.*\)$$/\1/p')
-
-ifeq ($(shell dpkg --compare-versions $(ICU_VERSION) ge 75;echo $$?),0)
-export ICU_CXXFLAGS := -std=c++17
-else
-export ICU_CXXFLAGS := -std=c++11
-endif
 
 # Enable ZTS build if $(DEB_SOURCE) ends with -zts
 ZTS=$(shell echo $(DEB_SOURCE) | sed 's/php$(PHP_MAJOR_VERSION).$(PHP_MINOR_VERSION)//')
@@ -131,7 +117,6 @@
 endif
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-  CONFIGURE_SYSTEMD := --with-fpm-systemd
   CONFIGURE_APPARMOR := --with-fpm-apparmor
 endif
 
@@ -187,7 +172,7 @@
 		--disable-debug \
 		--disable-rpath \
 		--disable-static \
-		--enable-dtrace \
+		--disable-dtrace \
 		--with-pic \
 		--with-layout=GNU \
 		--without-pear \
@@ -239,3 +224,14 @@
 		--prefix=/usr --enable-embed --enable-cli --disable-cgi --disable-phpdbg \
 		--with-config-file-path=/etc/php/$(PHP_NAME_VERSION)/embed \
 		--with-config-file-scan-dir=/etc/php/$(PHP_NAME_VERSION)/embed/conf.d \
+		$(COMMON_CONFIG) \
+		--without-mm \
+		--enable-pcntl
+
+export fpm_config = \
+		--prefix=/usr --enable-fpm --enable-cli --disable-cgi --disable-phpdbg \
+		--sysconfdir=/etc/php/$(PHP_NAME_VERSION)/fpm \
+		--with-fpm-user=www-data --with-fpm-group=www-data \
+		--with-fpm-acl \
+		--with-config-file-path=/etc/php/$(PHP_NAME_VERSION)/fpm \
+		--with-config-file-scan-dir=/etc/php/$(PHP_NAME_VERSION)/fpm/conf.d \
