## php8.4 8.4.15

=== debian/changelog ===
php8.4 (8.4.15-1+0~20251120.38+debian11~1.gbp1e3f4c) unstable; urgency=medium

  ** SNAPSHOT build @1e3f4cac5096444fe6cf0a238d60ebce16a63169 **

  * UNRELEASED

 -- Ondřej Surý <ondrej@sury.org>  Thu, 20 Nov 2025 20:02:10 +0100

php8.4 (8.4.15-1) unstable; urgency=medium

  * New upstream version 8.4.15

 -- Ondřej Surý <ondrej@debian.org>  Thu, 20 Nov 2025 18:38:19 +0100

php8.4 (8.4.14-3) unstable; urgency=medium

  * Or just use /bin/sed; that should work everywhere

 -- Ondřej Surý <ondrej@debian.org>  Thu, 20 Nov 2025 10:26:56 +0100

php8.4 (8.4.14-2) unstable; urgency=medium

  * Use command -v sed to resolve path to SED
  * Workaround make $(shell ...) command unable to execute builtins

 -- Ondřej Surý <ondrej@debian.org>  Thu, 20 Nov 2025 08:56:23 +0100

php8.4 (8.4.14-1) unstable; urgency=medium

  * New upstream version 8.4.14

 -- Ondřej Surý <ondrej@debian.org>  Mon, 27 Oct 2025 21:51:18 +0100

php8.4 (8.4.13-1) unstable; urgency=medium

  * New upstream version 8.4.13

 -- Ondřej Surý <ondrej@debian.org>  Wed, 01 Oct 2025 22:14:35 +0200

php8.4 (8.4.12-1) unstable; urgency=medium

  * New upstream version 8.4.12

 -- Ondřej Surý <ondrej@debian.org>  Fri, 29 Aug 2025 08:10:15 +0200
