=== debian/rules ===
--- 
+++ 
@@ -6,25 +6,24 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
+# Make the shell scripts fail after first failed command (important for SAPI loops)
+SHELL := /bin/sh -e
+
 # Hardcode correct absolute path to sed
-export ac_cv_path_SED = $(shell command -v sed)
+export ac_cv_path_SED := /bin/sed
+export SED := /bin/sed
 
 SANE_ARCHS := amd64 i386 arm64
 
 # Enable parallel builds
 PARALLEL=--parallel
-
-# Enable this for debugging the sed scripts
-#SED=$(CURDIR)/debian/sedsed
-export SED := /bin/sed
-
-# Make the shell scripts fail after first failed command (important for SAPI loops)
-SHELL := /bin/sh -e
 
 # enable dpkg build flags
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
+
+export PHP_BUILD_PROVIDER ?= Debian
 
 export DEB_HOST_MULTIARCH
 PHP_SOURCE_VERSION   := $(DEB_VERSION)
@@ -34,6 +33,14 @@
 PHP_MAJOR_VERSION    := $(shell echo $(PHP_DFSG_VERSION) | awk -F. '{print $$1}')
 PHP_MINOR_VERSION    := $(shell echo $(PHP_DFSG_VERSION) | awk -F. '{print $$2}')
 PHP_RELEASE_VERSION  := $(shell echo $(PHP_DFSG_VERSION) | awk -F. '{print $$3}')
+
+ICU_VERSION := $(shell dpkg -s libicu-dev | $(SED) -ne 's/^Version: \(.*\)$$/\1/p')
+
+ifeq ($(shell dpkg --compare-versions $(ICU_VERSION) ge 75;echo $$?),0)
+export ICU_CXXFLAGS := -std=c++17
+else
+export ICU_CXXFLAGS := -std=c++11
+endif
 
 # Enable ZTS build if $(DEB_SOURCE) ends with -zts
 ZTS=$(shell echo $(DEB_SOURCE) | sed 's/php$(PHP_MAJOR_VERSION).$(PHP_MINOR_VERSION)//')
@@ -117,6 +124,7 @@
 endif
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
+  CONFIGURE_SYSTEMD := --with-fpm-systemd
   CONFIGURE_APPARMOR := --with-fpm-apparmor
 endif
 
@@ -230,8 +238,3 @@
 
 export fpm_config = \
 		--prefix=/usr --enable-fpm --enable-cli --disable-cgi --disable-phpdbg \
-		--sysconfdir=/etc/php/$(PHP_NAME_VERSION)/fpm \
-		--with-fpm-user=www-data --with-fpm-group=www-data \
-		--with-fpm-acl \
-		--with-config-file-path=/etc/php/$(PHP_NAME_VERSION)/fpm \
-		--with-config-file-scan-dir=/etc/php/$(PHP_NAME_VERSION)/fpm/conf.d \
